#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Sun Mar 25 11:09:48 2018

@author: 
"""


import matplotlib.pyplot as plt 
import pandas as pd
excel_file = 'PlanBlocksR5_v1.xlsx'
planblock = pd.read_excel(excel_file,index_col='Block_ID')#在不写其他要求时，默认是第一个sheet
planblock.head()#可以用来读数据
#print planblock.head(5)
#print planblock.tail(5)

print planblock['Far_2004']#列选择
print planblock[1:4]#行选择,从0开始计数，此处相当于选择的是1、2、3行
print planblock[:3][['TAZ_ID','Far_2004']]#区块选择，先行后列
print planblock.at[432,'Far_2004']#单个单元格原则，根据设置的index，比如此处为根据blockid选择对应far2004
print planblock.iat[1,1]#单个单元格选择，根据索引
planblock.iat[1,1]=5#修改指定单元格的值
planblock.iat[1,1]=planblock.at[432,'Far_2004']+planblock.at[433,'Area_m2']#修改指定单元格数值

planblock_subset_columns = pd.read_excel(excel_file, parse_cols=6)#取前6列
planblock_subset_columns.head()

planblock['d_cbd'].plot(kind="hist")#用直方图的方式做频率图
plt.show()
print planblock.describe()

sorted_by_far2004 = planblock.sort_values(['Far_2004'], ascending=False)#用.sort方法排序
sorted_by_far2004.head()
sorted_by_far2004['Far_2004'].head(20).plot(kind="barh")#用来画图，其中head（20）说的是排名前20名，此参数可以改变
plt.show()

planblock["Far_change"] = planblock["Far_2017"] - planblock["Far_2004"]#减法计算，同理可以做加法计算
sorted_planblock = planblock[['Far_change']].sort_values(['Far_change'], ascending=[False])#sort方法排序
sorted_planblock.head(10)['Far_change'].plot.barh()#根据容积率变化最大的前十名作图，同时可以改成tail方法做后十名
plt.show()

planblock_subset = planblock[['TAZ_ID', 'Far_change']]  #以下是根据tazid做了容积率改变的数据透视表pivot
planblock_subset.head()
change_by_taz = planblock_subset.pivot_table(index=['TAZ_ID'])
change_by_taz.head()
change_by_taz.plot()
plt.show()


planblock.to_excel('output.xlsx')#导出，对于新计算的far_change也包含在这里